/*
 * ============================================================================
 * Licensed Materials - Property of IBM
 *  WebSphere sMash
 *
 * (C) Copyright IBM Corp. 2007,2008  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 * ============================================================================
 */
        /* Copyright (c) 2008 by IBM Corporation */

dojo.provide("zero.ide.widget.appedit.IWidgetCreateDialog");

dojo.require("zero.ide.widget.appedit.ZWidgetCreateDialog");

dojo.declare("zero.ide.widget.appedit.IWidgetCreateDialog",
             [zero.ide.widget.appedit.ZWidgetCreateDialog],
{
    widgetsInTemplate: true,
    templatePath: dojo.moduleUrl("zero","ide/widget/appedit/templates/IWidgetCreateDialog.html"),		
	
	getPath: function()
    {
        var zwname = this.zwNameInput.getValue();
		p = "/app/iwidgets/" + zwname + "/" + zwname;
		
		return this.resourceString+p+".xml";
    },

    getTemplateInstancePath: function()
    {
		var zwname = this.zwNameInput.getValue();
		var zwpackage = this.zwPackageInput.getValue();
		//p = "/app/iwidget/" + zwname + "/" + zwname;
		p =  "/"+zwname;
		var retString = this.templateInstanceString+p+"?template="+this.getTemplateName()+"&iwdesc="+zwpackage+"&iwname="+zwname;

/*		var iwuseiframeinput = this.zwUseiFrameInput.getValue();
		if (iwuseiframeinput) {
			var iwiframeurlinput = this.zwiFrameUrlInput.getValue();
			retString = retString + "&iwuseiframeinput="+iwuseiframeinput+"&iwiframeurlinput="+iwiframeurlinput;
		} 
*/

		var iwusecreatetestfile = this.zwCreateTestFileInput.getValue();
		if (iwusecreatetestfile) {
			var iwcreatetestfileinput = this.zwtestFileNameInput.getValue();
			retString = retString + "&iwusecreatetestfile="+iwusecreatetestfile+"&iwcreatetestfileinput="+iwcreatetestfileinput;
		} 
		if(zlog.isDebug())console.debug("in IWidgetCreateDialog getTemplateInstancePath returning "+retString);
				
		//return this.templateInstanceString+p+".xml?template="+this.getTemplateName()+"&iwdesc="+zwpackage+"&iwname="+zwname;
		return retString;
    },	
	
    checkForCreateTestFile: function(pEvent)
    {
		if(zlog.isDebug())console.debug("in IWidgetCreateDialog checkForCreateTestFile");
		
		var zwCreateTestFileInput = this.zwCreateTestFileInput.getValue();
		
		if (zwCreateTestFileInput) {
			this.zwtestFileNameInput.setAttribute('disabled',false);
            dojo.style(this.takeTestFileNameUl, "display", "");			
			dojo.removeClass(this.zwtestFileNameInputParent, "freedom-form-disabled-label");			
		} else {
			this.zwtestFileNameInput.setAttribute('disabled',true);
			dojo.style(this.takeTestFileNameUl, "display", "none");
			dojo.addClass(this.zwtestFileNameInputParent, "freedom-form-disabled-label");			
		}
		this.checkForCreateDisabled(pEvent);
		if(zlog.isDebug())console.debug("exit IWidgetCreateDialog checkForCreateTestFile");
    },	
	
/*    checkForUseiFrame: function(pEvent)
    {
		if(zlog.isDebug())console.debug("in IWidgetCreateDialog checkForUseiFrame");
		
		var zwUseiFrameInput = this.zwUseiFrameInput.getValue();
		
		if (zwUseiFrameInput) {
			this.zwiFrameUrlInput.setAttribute('disabled',false);
			dojo.removeClass(this.zwiFrameUrlInputParent, "freedom-form-disabled-label");			
		} else {
			this.zwiFrameUrlInput.setAttribute('disabled',true);
			dojo.addClass(this.zwiFrameUrlInputParent, "freedom-form-disabled-label");			
		}
		this.checkForCreateDisabled(pEvent);
		if(zlog.isDebug())console.debug("exit IWidgetCreateDialog checkForUseiFrame");

    },	
*/
	
    checkForCreateDisabled: function(pEvent)
    {
		if(zlog.isDebug())console.debug("in IWidgetCreateDialog checkForCreateDisabled");
		
		var disabledBut = true;
		var zwpackage = (this.zwPackageInput.getValue().length > 0) && this.zwPackageInput.isValid();
		var zwname = (this.zwNameInput.getValue().length > 0) && this.zwNameInput.isValid();

        if (zwpackage&&zwname) {  // if we have a name and desc it enabled unless an option is checked with no value
			disabledBut = false;

/*		    var zwUseiFrameInput = this.zwUseiFrameInput.getValue();	
		    if (zwUseiFrameInput) {  // check to see if use iframe is checked and has a value
		        var iwiframeurlinput = (this.zwiFrameUrlInput.getValue().length > 0) && this.zwiFrameUrlInput.isValid(); 
		        if (!iwiframeurlinput) {
				   disabledBut = true;
				}
			}
*/			
		    //var zwCreateFullSampleInput = this.zwCreateFullSampleInput.getValue();
			var zwCreateTestFileInput = this.zwCreateTestFileInput.getValue();	
		    if (zwCreateTestFileInput) {  // check to see if use test file is checked and has a value
		        var zwtestFileNameInput = ((this.zwtestFileNameInput.getValue().length > 0) && this.zwtestFileNameInput.isValid()); 
		        if (!zwtestFileNameInput) {
				   disabledBut = true;
		           if(zlog.isDebug())console.debug("in IWidgetCreateDialog checkForCreateDisabled no test file set so disable");
				}
			}
		} else {
			disabledBut = true;
		}
		if (disabledBut) {
            this.createButton.setAttribute('disabled',true);
			this.disabledButton = true;
		    if(zlog.isDebug())console.debug("exit IWidgetCreateDialog checkForCreateDisabled return true");
			return true;			
		} else {
			this.createButton.setAttribute('disabled', false);
			this.disabledButton = false;
            if (pEvent && pEvent.keyCode == dojo.keys.ENTER) {
				this._fileCreate();
				this.hide();
			}			
		    if(zlog.isDebug())console.debug("exit IWidgetCreateDialog checkForCreateDisabled return false");			
			return false;
		}
    },	

	
	openTitle: "Create an iWidget"	
});
